/**
* Utility class library
*
* ===========
* = WARNING =
* ===========
*
* Please take caution to make sure that the utility naming and values are consistent. We'd like to
* be able to automate this file in the future.
*
* Naming conventions
*
* - Prefix the utility names with the gl- namespace
* - Use t(op), b(ottom), l(eft), and r(ight) to indicate
*   positioning variations, i.e. gl-border-b-1
*/

/**
* Padding utilities.
*
* naming convention: gl-p{position}-{spacing-scale-index}
* notes:
* - Utilities should strictly follow $gl-spacing-scale
*/
@mixin gl-p-0 { padding: $gl-spacing-scale-0; }

@mixin gl-p-1 { padding: $gl-spacing-scale-1; }

@mixin gl-p-3 { padding: $gl-spacing-scale-3; }

@mixin gl-p-4 { padding: $gl-spacing-scale-4; }

@mixin gl-p-5 { padding: $gl-spacing-scale-5; }

@mixin gl-px-3 {
  padding-left: $gl-spacing-scale-3;
  padding-right: $gl-spacing-scale-3;
}

@mixin gl-px-4 {
  padding-left: $gl-spacing-scale-4;
  padding-right: $gl-spacing-scale-4;
}

@mixin gl-pr-2 { padding-right: $gl-spacing-scale-2; }

@mixin gl-pr-3 { padding-right: $gl-spacing-scale-3; }

@mixin gl-pr-5 { padding-right: $gl-spacing-scale-5; }

@mixin gl-pr-9 { padding-right: $gl-spacing-scale-9; }

@mixin gl-pl-0 { padding-left: $gl-spacing-scale-0; }

@mixin gl-pl-2 { padding-left: $gl-spacing-scale-2; }

@mixin gl-pl-3 { padding-left: $gl-spacing-scale-3; }

@mixin gl-pl-6 { padding-left: $gl-spacing-scale-6; }

@mixin gl-py-0 {
  padding-top: $gl-spacing-scale-0;
  padding-bottom: $gl-spacing-scale-0;
}

@mixin gl-py-6 {
  padding-top: $gl-spacing-scale-6;
  padding-bottom: $gl-spacing-scale-6;
}

@mixin gl-pt-5 { padding-top: $gl-spacing-scale-5; }

@mixin gl-pb-2 { padding-bottom: $gl-spacing-scale-2; }

@mixin gl-pb-3 { padding-bottom: $gl-spacing-scale-3; }

@mixin gl-pb-4 { padding-bottom: $gl-spacing-scale-4; }

@mixin gl-py-2 {
  padding-top: $gl-spacing-scale-2;
  padding-bottom: $gl-spacing-scale-2;
}

@mixin gl-py-3 {
  padding-top: $gl-spacing-scale-3;
  padding-bottom: $gl-spacing-scale-3;
}

@mixin gl-py-4 {
  padding-top: $gl-spacing-scale-4;
  padding-bottom: $gl-spacing-scale-4;
}

@mixin gl-py-5 {
  padding-top: $gl-spacing-scale-5;
  padding-bottom: $gl-spacing-scale-5;
}

/**
* Margin utilities.
*
* naming convention: gl-m{position}-{spacing-scale-index}
* notes:
* - Utilities should strictly follow $gl-spacing-scale
*/
@mixin gl-m-0 { margin: $gl-spacing-scale-0; }

@mixin gl-mt-0 { margin-top: $gl-spacing-scale-0; }

@mixin gl-mt-1 { margin-top: $gl-spacing-scale-1; }

@mixin gl-mt-2 { margin-top: $gl-spacing-scale-2; }

@mixin gl-mt-3 { margin-top: $gl-spacing-scale-3; }

@mixin gl-mt-5 { margin-top: $gl-spacing-scale-5; }

@mixin gl-mr-2 { margin-right: $gl-spacing-scale-2; }

@mixin gl-mr-3 { margin-right: $gl-spacing-scale-3; }

@mixin gl-mr-5 { margin-right: $gl-spacing-scale-5; }

@mixin gl-mb-1 { margin-bottom: $gl-spacing-scale-1; }

@mixin gl-mb-2 { margin-bottom: $gl-spacing-scale-2; }

@mixin gl-mb-3 { margin-bottom: $gl-spacing-scale-3; }

@mixin gl-mb-4 { margin-bottom: $gl-spacing-scale-4; }

@mixin gl-mb-5 { margin-bottom: $gl-spacing-scale-5; }

@mixin gl-ml-auto { margin-left: auto; }

@mixin gl-ml-0 { margin-left: $gl-spacing-scale-0; }

@mixin gl-ml-1 { margin-left: $gl-spacing-scale-1; }

@mixin gl-ml-3 { margin-left: $gl-spacing-scale-3; }

@mixin gl-my-auto {
  margin-top: auto;
  margin-bottom: auto;
}

@mixin gl-my-5 {
  margin-top: $gl-spacing-scale-5;
  margin-bottom: $gl-spacing-scale-5;
}

@mixin gl-my-11 {
  margin-top: $gl-spacing-scale-11;
  margin-bottom: $gl-spacing-scale-11;
}

@mixin gl-mx-auto {
  margin-left: auto;
  margin-right: auto;
}

@mixin gl-mx-0 {
  margin-left: $gl-spacing-scale-0;
  margin-right: $gl-spacing-scale-0;
}

@mixin gl-my-2 {
  margin-top: $gl-spacing-scale-2;
  margin-bottom: $gl-spacing-scale-2;
}

@mixin gl-mx-3 {
  margin-left: $gl-spacing-scale-3;
  margin-right: $gl-spacing-scale-3;
}

/**
* Fixed dimension (width/height) utilities
*
* naming convention: gl-{width|height}-{spacing-scale-index}
* notes:
* - Utilities should strictly follow $gl-spacing-scale
*/
@mixin gl-w-3 { width: $gl-spacing-scale-3; }

@mixin gl-w-4 { width: $gl-spacing-scale-4; }

@mixin gl-w-5 { width: $gl-spacing-scale-5; }

@mixin gl-w-6 { width: $gl-spacing-scale-6; }

@mixin gl-w-7 { width: $gl-spacing-scale-7; }

@mixin gl-w-9 { width: $gl-spacing-scale-9; }

@mixin gl-w-10 { width: $gl-spacing-scale-10; }

@mixin gl-w-11 { width: $gl-spacing-scale-11; }

@mixin gl-w-13 { width: $gl-spacing-scale-13; }

@mixin gl-w-full { width: 100%; }

@mixin gl-h-auto { height: auto; }

@mixin gl-h-0 { height: $gl-spacing-scale-0; }

@mixin gl-h-4 { height: $gl-spacing-scale-4; }

@mixin gl-h-5 { height: $gl-spacing-scale-5; }

@mixin gl-h-6 { height: $gl-spacing-scale-6; }

@mixin gl-h-7 { height: $gl-spacing-scale-7; }

@mixin gl-h-8 { height: $gl-spacing-scale-8; }

@mixin gl-h-9 { height: $gl-spacing-scale-9; }

@mixin gl-h-11 { height: $gl-spacing-scale-11; }

@mixin gl-h-13 { height: $gl-spacing-scale-13; }

@mixin gl-h-6 { height: $gl-spacing-scale-6; }

/**
* Outline utilities.
*
* naming convention: gl-outline-{style}
*/
@mixin gl-outline-0 { outline: 0; }

/**
* Border style utilities.
*
* naming convention: gl-border-{position}-{style}
*/
@mixin gl-border-none { border-style: none; }

@mixin gl-border-solid { border-style: solid; }

@mixin gl-border-t-solid { border-top-style: solid; }

@mixin gl-border-b-solid { border-bottom-style: solid; }

@mixin gl-border-t-none { border-top-style: none; }
.gl-border-t-none { @include gl-border-t-none; }

@mixin gl-outline-none { outline: none; }

/**
* Border color utilities.
*
* naming convention: gl-border-{position}-{color-palette-variable}
* notes:
* - Prefer design system color palette. See variables.scss
* for a comprehensive list.
*/
@mixin gl-border-white-light { border-color: $white-light; }

@mixin gl-border-gray-200 { border-color: $gray-200; }

@mixin gl-border-gray-300 { border-color: $gray-300; }

@mixin gl-border-blue-600 { border-color: $blue-600;; }

@mixin gl-border-t-gray-a-08 { border-color: $t-gray-a-08; }

@mixin gl-border-t-gray-200 { border-top-color: $gray-200; }

@mixin gl-border-r-gray-200 { border-right-color: $gray-200; }

@mixin gl-border-b-gray-200 { border-bottom-color: $gray-200; }

@mixin gl-border-l-gray-200 { border-left-color: $gray-200; }

@mixin gl-border-t-blue-600 { border-top-color: $blue-600; }

@mixin gl-border-r-blue-600 { border-right-color: $blue-600; }

@mixin gl-border-b-blue-600 { border-bottom-color: $blue-600; }

@mixin gl-border-l-blue-600 { border-left-color: $blue-600; }

/**
* Border width utilities.
*
* naming convention: gl-border-{position}-{border-width}
* notes:
* - Base new utilities in this group in the $gl-border-size variable
*/
@mixin gl-border-0 { border-width: $gl-border-size-0; }

@mixin gl-border-1 { border-width: $gl-border-size-1; }

@mixin gl-border-t-1 { border-top-width: $gl-border-size-1; }

@mixin gl-border-b-1 { border-bottom-width: $gl-border-size-1; }

/**
* Border radius utilities.
*
* naming convention: gl-rounded-{roundness-size}
* notes:
* - Base new utilities in this group in the $gl-border-radius variables
*/
@mixin gl-rounded-0 { border-radius: 0; }

@mixin gl-rounded-base { border-radius: $gl-border-radius-base; }

@mixin gl-rounded-full { border-radius: $gl-border-radius-full; }

@mixin gl-rounded-small { border-radius: $gl-border-radius-small; }

@mixin gl-rounded-lg { border-radius: $gl-border-radius-large; }

@mixin gl-rounded-pill { border-radius: $gl-spacing-scale-4; }

@mixin gl-rounded-top-left-base { border-top-left-radius: $gl-border-radius-base; }

@mixin gl-rounded-top-right-base { border-top-right-radius: $gl-border-radius-base; }

@mixin gl-rounded-bottom-left-base { border-bottom-left-radius: $gl-border-radius-base; }

@mixin gl-rounded-bottom-right-base { border-bottom-right-radius: $gl-border-radius-base; }

/**
* Font family utility
*
* naming convention: gl-font-{family-name}
* Notes:
* - Strictly based on design system typography specs
*/
@mixin gl-font-monospace { font-family: $gl-monospace-font; }

@mixin gl-font-regular { font-family: $gl-regular-font; }

/**
* Font size utility
*
* naming convention: gl-font-{type-scale-size}
* Notes:
* - Strictly based on design system type scale. See
* $gl-type-scale for further references.
*/
@mixin gl-font-sm { font-size: $gl-type-scale-sm; }

@mixin gl-font-base { font-size: $gl-type-scale-base; }

@mixin gl-font-xl { font-size: $gl-type-scale-xl; }

@mixin gl-font-2xl { font-size: $gl-type-scale-2xl; }

@mixin gl-font-3xl { font-size: $gl-type-scale-3xl; }

@mixin gl-font-icon-size {font-size: $default-icon-size; }

/**
* Font-weight utilities.
*
* naming convention: gl-font-weight-[bold|normal]
*/
@mixin gl-font-weight-normal { font-weight: $gl-font-weight-normal; }

@mixin gl-font-weight-bold { font-weight: $gl-font-weight-bold; }

/**
* Text color utilities.
*
* naming convention: gl-text-{color-palette-variable-name}
* notes:
* - Strictly based design system color palette. See variables.scss
* for a comprehensive list.
*/
@mixin gl-text-white { color: $white; }

@mixin gl-text-white-light { color: $white-light; }

@mixin gl-text-black-normal { color: $black-normal; }

@mixin gl-text-gray-400 { color: $gray-400; }

@mixin gl-text-gray-500 { color: $gray-500; }

@mixin gl-text-gray-600 { color: $gray-600; }

@mixin gl-text-gray-700 { color: $gray-700; }

@mixin gl-text-gray-900 { color: $gray-900; }

@mixin gl-text-gray-950 { color: $gray-950; }

@mixin gl-text-blue-300 { color: $blue-300; }

@mixin gl-text-blue-500 { color: $blue-500; }

@mixin gl-text-blue-600 { color: $blue-600; }

@mixin gl-text-blue-700 { color: $blue-700; }

@mixin gl-text-green-400 { color: $green-400; }

@mixin gl-text-green-500 { color: $green-500; }

@mixin gl-text-green-600 { color: $green-600; }

@mixin gl-text-green-700 { color: $green-700; }

@mixin gl-text-orange-500 { color: $orange-500; }

@mixin gl-text-orange-600 { color: $orange-600; }

@mixin gl-text-orange-700 { color: $orange-700; }

@mixin gl-text-red-500 { color: $red-500; }

@mixin gl-text-red-600 { color: $red-600; }

@mixin gl-text-red-700 { color: $red-700; }

@mixin gl-text-blue-500 { color: $blue-500; }

/**
* Line height utilities.
*
* naming convention: gl-line-height-{line-height-in-pixels}
* notes:
* - Strictly based in gl-line-height-{n} variables
*/
@mixin gl-line-height-normal { line-height: $gl-line-height; }

@mixin gl-line-height-24 { line-height: $gl-line-height-24; }

@mixin gl-line-height-32 { line-height: $gl-line-height-32; }

@mixin gl-line-height-52 { line-height: $gl-line-height-52; }

/**
* Text align utilities
*/
@mixin gl-text-left { text-align: left; }

@mixin gl-text-center { text-align: center; }

@mixin gl-text-left { text-align: left; }

/**
* Text utilities
*/
@mixin gl-text-decoration-none { text-decoration: none; }

@mixin gl-text-transform-none { text-transform: none; }

/**
* Vertical align utilities
*/
@mixin gl-vertical-align-middle { vertical-align: middle; }

@mixin gl-vertical-align-top { vertical-align: top; }

/**
* White space utilities
*/
@mixin gl-white-space-normal { white-space: normal; }

@mixin gl-white-space-nowrap { white-space: nowrap; }

/**
* Inset border utilities
*
* Uses box-shadow: inset to create a border that does not
* increase the box size of an element
*
* Naming convention: gl-inset-border-{border-position}-{border-size}-{color-name}
*/
@mixin gl-inset-border-1-gray-200 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $gray-200;
}

@mixin gl-inset-border-1-gray-400 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $gray-400;
}

@mixin gl-inset-border-b-2-gray-200 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $gray-200;
}

@mixin gl-inset-border-1-blue-500 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $blue-500;
}

@mixin gl-inset-border-1-blue-600 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $blue-600;
}

@mixin gl-inset-border-1-green-500 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $green-500;
}

@mixin gl-inset-border-1-green-600 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $green-600;
}

@mixin gl-inset-border-1-orange-500 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $orange-500;
}

@mixin gl-inset-border-1-orange-600 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $orange-600;
}

@mixin gl-inset-border-1-red-500 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $red-500;
}

@mixin gl-inset-border-1-red-600 {
  box-shadow: inset 0 0 0 $gl-border-size-1 $red-600;
}

@mixin gl-inset-border-b-2-theme-indigo-500 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $theme-indigo-500;
}

@mixin gl-inset-border-b-2-theme-red-500 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $theme-red-500;
}

@mixin gl-inset-border-b-2-theme-light-red-500 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $theme-light-red-500;
}

@mixin gl-inset-border-b-2-theme-blue-500 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $theme-blue-500;
}

@mixin gl-inset-border-b-2-theme-light-blue-500 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $theme-light-blue-500;
}

@mixin gl-inset-border-b-2-theme-green-500 {
  box-shadow: inset 0 ($gl-border-size-2 * -1) 0 0 $theme-green-500;
}

/**
* Box shadow utilities
*
* naming convention: gl-shadow-{config-name}
*/
@mixin gl-shadow-none { box-shadow: none; }

@mixin gl-shadow { box-shadow: 0 2px 3px 1px $gray-200; }

/**
* Display utilities
*
* Naming convention gl-display-{property-value}
*/
@mixin gl-display-flex { display: flex; }

@mixin gl-display-inline-flex { display: inline-flex; }

@mixin gl-display-block { display: block; }

@mixin gl-display-inline-block { display: inline-block; }

/**
* Flexbox utilities
*/
@mixin gl-align-items-baseline { align-items: baseline; }

@mixin gl-align-items-center { align-items: center; }

@mixin gl-flex-wrap { flex-wrap: wrap; }

@mixin gl-flex-direction-column { flex-direction: column; }

@mixin gl-flex-direction-row { flex-direction: row; }

@mixin gl-justify-content-center { justify-content: center; }

@mixin gl-align-self-start { align-self: flex-start; }

@mixin gl-align-self-center { align-self: center; }

/**
* Position utilities.
*
* naming convention: gl-{property-value}
*/
@mixin gl-relative { position: relative; }

@mixin gl-absolute { position: absolute; }

@mixin gl-static { position: static; }

/**
* Placement utilities.
*
* For absolute or fixed positioned elements
*
* naming convention: gl-{position}-{spacing-scale-index}
*/
@mixin gl-bottom-1 { bottom: $gl-spacing-scale-1; }

@mixin gl-bottom-6 { bottom: $gl-spacing-scale-6; }

@mixin gl-left-6 { left: $gl-spacing-scale-6; }

/**
* Overflow utilities.
*
* naming convention: gl-overflow-{property-value} |
* gl-overflow-x-{property-value} | gl-overflow-y-{property-value}
*/
@mixin gl-overflow-hidden { overflow: hidden; }

@mixin gl-relative { position: relative; }

/**
* Placement utilities
*
* naming convention: gl-{position}-{value}
*/
@mixin gl-top-0 { top: 0; }

@mixin gl-top-1 { top: $gl-spacing-scale-1; }

@mixin gl-right-0 { right: 0; }

@mixin gl-right-1 { right: $gl-spacing-scale-1; }

@mixin gl-left-0 { left: 0; }

@mixin gl-left-1 { left: $gl-spacing-scale-1; }

/**
* Overflow utilities.
*
* naming convention: gl-overflow-{property-value} |
* gl-overflow-x-{property-value} | gl-overflow-y-{property-value}
*/
@mixin gl-overflow-hidden { overflow: hidden; }

/**
* Cursor utilities
*
* naming convention: gl-cursor-{property-value}
*/
@mixin gl-cursor-default { cursor: default; }

@mixin gl-cursor-pointer { cursor: pointer; }

@mixin gl-cursor-not-allowed { cursor: not-allowed; }

@mixin gl-cursor-not-allowed { cursor: not-allowed; }

@mixin gl-user-select-none { user-select: none; }

/**
* Background color utilities.
*
* naming convention: gl-bg-{color-palette-variable-name}
* notes:
* - Strictly based design system color palette. See variables.scss
* for a comprehensive list.
*/
@mixin gl-bg-transparent { background-color: $transparent; }

@mixin gl-bg-white { background-color: $white; }

@mixin gl-bg-white-light { background-color: $white-light; }

@mixin gl-bg-gray-50 { background-color: $gray-50; }

@mixin gl-bg-gray-100 { background-color: $gray-100; }

@mixin gl-bg-gray-200 { background-color: $gray-200; }

@mixin gl-bg-gray-300 { background-color: $gray-300; }

@mixin gl-bg-gray-600 { background-color: $gray-600; }

@mixin gl-bg-blue-100 { background-color: $blue-100; }

@mixin gl-bg-blue-200 { background-color: $blue-200; }

@mixin gl-bg-blue-500 { background-color: $blue-500; }

@mixin gl-bg-blue-600 { background-color: $blue-600; }

@mixin gl-bg-blue-700 { background-color: $blue-700; }

@mixin gl-bg-green-100 { background-color: $green-100; }

@mixin gl-bg-green-200 { background-color: $green-200; }

@mixin gl-bg-green-500 { background-color: $green-500; }

@mixin gl-bg-green-600 { background-color: $green-600; }

@mixin gl-bg-green-700 { background-color: $green-700; }

@mixin gl-bg-orange-100 { background-color: $orange-100; }

@mixin gl-bg-orange-200 { background-color: $orange-200; }

@mixin gl-bg-orange-500 { background-color: $orange-500; }

@mixin gl-bg-orange-600 { background-color: $orange-600; }

@mixin gl-bg-orange-700 { background-color: $orange-700; }

@mixin gl-bg-red-100 { background-color: $red-100; }

@mixin gl-bg-red-200 { background-color: $red-200; }

@mixin gl-bg-red-500 { background-color: $red-500; }

@mixin gl-bg-red-600 { background-color: $red-600; }

@mixin gl-bg-red-700 { background-color: $red-700; }

@mixin gl-bg-none { background: none; }

/**
* Background position utilities.
*
* naming convention: gl-bg-{position}
*/
@mixin gl-bg-center { background-position: center; }

/**
* Background size utilities.
*
* naming convention: gl-bg-{repeat-pattern}
*/
@mixin gl-bg-size-100p { background-size: 100% 100%; }

@mixin gl-bg-size-cover { background-size: cover; }

/**
* Background repeat utilities.
*
* naming convention: gl-bg-{repeat-pattern}
*/
@mixin gl-bg-no-repeat { background-repeat: no-repeat; }

/**
* Background image utilities.
*
* naming convention: gl-bg-{image-name}
*/
@mixin gl-bg-chevron-left-sm { background-image: url($gl-icon-chevron-left-sm); }

@mixin gl-bg-chevron-right-sm { background-image: url($gl-icon-chevron-right-sm); }

/**
* Transition utilities
*
* naming convention: gl-transition-{speed}
*/
@mixin gl-transition-slow { transition: all 0.4s ease; }

@mixin gl-transition-medium { transition: all 0.2s ease; }

/**
* Opacity utilities
*
* naming convention: gl-opacity-{amount}
*/
@mixin gl-opacity-10 { opacity: 1; }

@mixin gl-opacity-5 { opacity: 0.5; }

@mixin gl-opacity-4 { opacity: 0.4; }

/**
* Content utilities.
*
* naming convention: gl-content-{value}
*/
@mixin gl-content-empty { content: ''; }

/**
* Fill (svg) utilities.
*
* naming convention: gl-fill-{color-palette-variable-name}
*/
@mixin gl-fill-gray-700 { fill: $gray-700; }

/**
* White-space utilities.
*
* naming convention: gl-white-space-{value}
*/
@mixin gl-white-space-normal { white-space: normal; }

@mixin gl-white-space-nowrap { white-space: nowrap; }
